#include "sagem.h"

void boot_chksum(byte * data, word size, dword * chksum, byte * shift)
{
	word i;

	for (i = 0; i < size; i++) {
		*chksum += data[i] << *shift;
		(*shift)++;
		*shift %= 0x0D;
	}
}

void boot_chksum_all(byte * data, word size, word * chksum)
{
	byte x;
	dword i;

	*chksum = 0;
	for (i = 0; i < 0x3FFFE; i++) {
		x = i < size ? data[i] : -1;
		*chksum += i & 1 ? x << 8 : x;
	}
}

dword boot_crypt_sub(dword * buffer)
{
	word i, carry = 0;
	dword x, out = 0;

	for (i = 0; i < 8; i++) {
		x = buffer[i] + (buffer[i] << 4) + (buffer[i] << 5) + (buffer[i] << 6) + carry;
		carry = x >> 20;
		x &= 0xFFFFF;
		buffer[i] = x;
		out += x;
	}

	return out;
}

void boot_crypt(byte offset, byte * data)
{
	byte buffer[0x20];
	dword i, j, x;

	for (i = 0; i < 0x20; i++) buffer[i] = data[i + offset];
	for (i = 0; i < 0x80; i++) {
		for (j = 0; j < 8; j++) {
			x <<= 1;
			x |= boot_crypt_sub((dword *) buffer) & 1;
		}
		data[i] ^= x;
	}
}
